<template>
  <div class="instance-block">
    <div v-if="bannerUrl && !bannerError" class="banner-container">
      <img width="600" height="100" class="banner" :src="bannerUrl" alt="" @error="bannerError = true">
    </div>

    <div class="card instance-card" :class="{ 'has-banner': bannerUrl && !bannerError }">

      <div class="d-flex justify-content-between">
        <div class="left">
          <div class="title d-flex align-items-baseline flex-wrap mb-1">
            <h3 class="me-2 mb-0"><strong>{{ instance.name }}</strong></h3>

            <div class="small-description text-nowrap">{{ instance.host }}</div>
          </div>

          <div class="small-separator"></div>

          <p class="mt-3 me-3" :title="instance.shortDescription">{{ truncatedDescription }}</p>

          <div class="tags">
            <template v-for="language in languages" :key="language">
              <span class="tag">{{ language }}</span>
            </template>

            <template v-for="category in limitedCategories" :key="category">
              <span class="tag tag-secondary">{{ category }}</span>
            </template>
          </div>
        </div>

        <div class="right d-flex flex-column flex-wrap">
          <template v-if="isVideoMaker">
            <div class="small-description">
              <div v-if="instance.userVideoQuota">
                {{ bytes(instance.userVideoQuota) }}
                <span>{{ $gettext('per user') }}</span>
              </div>

              <div v-else>
                {{ $gettext('No video quota per user') }}
              </div>
            </div>

            <div v-if="instance.autoBlacklistUserVideosEnabled" class="small-description">
              {{ $gettext('Video publication after moderation') }}
            </div>

            <template v-if="instance.signupRequiresApproval && averageRegistrationRequestResponseTimeDays">
              <div class="small-description">
                {{ $ngettext('Approve accounts in ~1 day', 'Approve accounts in ~%{ days } days', averageRegistrationRequestResponseTimeDays, { days: averageRegistrationRequestResponseTimeDays }) }}
              </div>
            </template>

            <div class="small-description">
              {{ $ngettext('%{ total } follower', '%{ total } followers', instance.totalInstanceFollowers, { total: instance.totalInstanceFollowers }) }}
            </div>
          </template>

          <template v-else>
            <div class="small-description">
              {{ $ngettext('%{total } subscription', '%{total } subscriptions', instance.totalInstanceFollowing, { total: instance.totalInstanceFollowing }) }}
            </div>

            <div class="small-description">
              {{ $ngettext('%{total} video', '%{total} videos', instance.totalVideos, { total: instance.totalVideos.toLocaleString() }) }}
            </div>
          </template>

          <div class="small-description">
            <div v-if="instance.defaultNSFWPolicy === 'do_not_list'">{{ $gettext('Sensitive content not displayed') }}</div>
            <div v-if="instance.defaultNSFWPolicy === 'blur'">{{ $gettext('Sensitive content blurred') }}</div>
            <div v-if="instance.defaultNSFWPolicy === 'display'">{{ $gettext('Sensitive content displayed') }}</div>
          </div>

          <div class="link text-nowrap">
            <a :href="getUrl(instance)" class="jpt-router-link" target="_blank" rel="noopener noreferrer">
              <span v-if="!isVideoMaker" class="text">{{ $gettext('Go to this platform') }}</span>
              <span v-else-if="instance.signupRequiresApproval" class="text">{{ $gettext('Apply for an account') }}</span>
              <span v-else class="text">{{ $gettext('Create an account') }}</span>
            </a>

            <icon-right></icon-right>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import { defineComponent } from 'vue'

  import IconRight from './icons/IconRight.vue'
  import { truncate } from 'lodash-es'
  import { findAppropriateImageByWidth } from '../shared/utils'

  export default defineComponent({
    components: {
      IconRight
    },

    props: {
      instance: Object,
      translatedThemes: Object,
      translatedLanguages: Object,
      isVideoMaker: Boolean
    },

    data () {
      return {
        bannerError: false
      }
    },

    computed: {
      truncatedDescription () {
        const t = this.instance.shortDescription

        return truncate(t, { separator: /,? /, length: 200 })
      },

      languages () {
        return this.instance.languages
          .map(l => this.translatedLanguages[l])
          .filter(l => !!l)
      },

      limitedCategories () {
        if (Array.isArray(this.instance.categories) === false) return []

        return this.instance.categories
          .map(l => this.translatedThemes[l])
          .filter(l => !!l)
          .slice(0, 3)
          .map(l => `#${l}`)
      },

      bannerUrl () {
        if (!Array.isArray(this.instance.banners) || this.instance.banners.length === 0) return ''

        return findAppropriateImageByWidth(this.instance.banners, 600).url
      },

      averageRegistrationRequestResponseTimeDays () {
        if (!this.instance.averageRegistrationRequestResponseTimeMs) return null

        return Math.max(Math.round(this.instance.averageRegistrationRequestResponseTimeMs / (3600 * 24 * 1000)), 1)
      }
    },

    mounted () {

    },

    methods: {
      bytes (value) {
        if (value === -1) return this.$gettext('Unlimited space')

        // https://github.com/danrevah/ngx-pipes/blob/master/src/pipes/math/bytes.ts
        const dictionaryBytes = [
          { max: 1024, type: this.$gettext('B') },
          { max: 1048576, type: this.$gettext('KB') },
          { max: 1073741824, type: this.$gettext('MB') },
          { max: 1.0995116e12, type: this.$gettext('GB') }
        ]

        const format = dictionaryBytes.find(function (d) { return value < d.max }) || dictionaryBytes[dictionaryBytes.length - 1]
        const calc = Math.floor(value / (format.max / 1024)).toString()

        return calc + format.type
      },

      getUrl (instance) {
        const base = `https://${instance.host}`

        if (!this.isVideoMaker) return base

        return base + '/signup'
      }
    }
  })
</script>

<style lang="scss" scoped>
  @import '../scss/_variables.scss';
  @import '../scss/_mixins.scss';
  @import '../scss/_bootstrap-mixins.scss';

  .banner-container {
    background: #fff;
    border: 1px solid #FFC99E;
    border-bottom: 0;
  }

  .banner {
    margin-top: -1px;
    margin-left: -1px;

    max-width: calc(100% + 2px);
    width: calc(100% + 2px);
    height: calc(100% + 1px);
  }

  .banner,
  .banner-container {
    border-top-left-radius: 4px;
    border-top-right-radius: 4px;
  }

  .instance-card {
    @include font-size-14px;
    @include adapt-link-size-14px;
    @include padding(2rem 1.5rem);
    @include margin-bottom(3rem);

    &.has-banner {
      padding-top: 1rem;
      border-top: 0;
      border-top-left-radius: 0;
      border-top-right-radius: 0;
    }

    .left {
      margin-inline-end: 10px;
    }

    .right {
      min-width: 180px;

      .small-description {
        margin-bottom: 3px;
      }
    }

    h3 {
      @include font-size(1.25rem);

      font-family: inherit;
    }

    .small-description {
      @include font-size-14px;
      @include adapt-link-size-14px;
    }

    .small-separator {
      width: 25px;
      height: 3px;
    }

    .link {
      padding-top: 15px;
      margin-top: auto;
      text-align: right;

      .jpt-router-link {
        margin-inline-end: 10px;
      }
    }

    .tags {
      display: flex;
      flex-wrap: wrap;

      .tag {
        @include font-size-14px;
        @include padding(0.25rem 0.5rem);

        line-height: 1.25;
        border: 2px solid;
        border-color: $beige-800;
        border-radius: 15px;
        margin-bottom: 0.5rem;

        &:not(:last-child) {
          margin-inline-end: 5px;
        }

        &.tag-secondary {
          border-color: $beige-800;
        }
      }
    }

    @include media-breakpoint-down(sm) {
      > .d-flex {
        flex-wrap: wrap;
      }

      .link {
        text-align: left;
      }
    }
  }
</style>
